=== share/CMakeLists.txt ===

add_subdirectory(metview/app-defaults)

add_subdirectory(metview/etc)

if(ENABLE_MOTIF)
    add_subdirectory(metview/icons)
endif()

add_subdirectory(metview/icons_mv5)





#install ( DIRECTORY metview
#          DESTINATION share FILE_PERMISSIONS OWNER_READ GROUP_READ WORLD_READ)

## NEED TO COPY TO BUILD DIRECTORY!!!!

#configure_file(metview ../share COPYONLY)
