=== src/Datacoverage/CMakeLists.txt ===

set(Datacoverage_srcs
    Datacoverage.cc Datacoverage.h
)


ecbuild_add_executable( TARGET       Datacoverage
                        SOURCES      ${Datacoverage_srcs}
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES}
                        LIBS         ${STANDARD_METVIEW_LIBS} ${METVIEW_EXTRA_LIBRARIES}
                    )
