=== src/Divrot/CMakeLists.txt ===

set(Divrot_srcs
    Divrot.cc divrot-exFortran.cc Divrot.h
)


ecbuild_add_executable( TARGET       Divrot
                        SOURCES      ${Divrot_srcs}
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES}
                        LIBS         ${STANDARD_METVIEW_LIBS} ${METVIEW_EXTRA_LIBRARIES}
                    )
