=== debian/changelog ===
metview (5.0.0~beta.1-1build1) bionic; urgency=medium

  * Rebuild against new libgdbm5.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 02 Feb 2018 15:25:47 +0100

metview (5.0.0~beta.1-1) unstable; urgency=medium

  * New upstream release
  * Set chmod 644 on ssvg images in metview
  * Standards-Version: 4.1.3; no  changes required
  * Move python scripts to python3; dep. on it, not python
  * Set -dev pkg to MultiArch: same (not foreign; contains static libs)

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 04 Jan 2018 12:31:09 +0000
